#!/usr/bin/perl

################################################################
## search for anything that looks like a java file with a line number
## e.g. /some/file.java:1234
## java stack trace or java compiler error
## 
## line number becomes ACT_PATH_LINE variable
## file path becames ACT_SEARCH_FILE
## The script will try to guess appropriate path for java Class name, if needed
##
## In case the file path is just a fragment (not a full path),
## Tactor will search for the best match
##
##	NOTE: if you want to modify this script, copy it to your home directory first
##	~/Library/Application Support/Tactor/PlugIns/
##	Otherwise it may get overwriten next time you update Tactor
################################################################

sub matches_context {
	$TEXT = $CONTEXT{'CTX_TEXT'};
	foreach (split ('[\n;]', $TEXT)) {
		$l = $_;
		if ($l =~ m/ at line: (\d+) in the jsp file: (\/[^ ]+.jsp)/) {
			$CONTEXT{'ACT_PATH_LINE'} = $1;
			return 1;
		}
		elsif ($l =~ m/ at ([a-z][a-zA-Z0-9_\.\$]+)\(([A-Za-z0-9_]+\.java):(\d+)\)/) {
			$CONTEXT{'ACT_PATH_LINE'} = $3;
			my @cl = split ('\.', "$1"); pop (@cl); pop (@cl);
			my $f = join ('/', @cl) . "/" . $2;
			$CONTEXT{'ACT_SEARCH_FILE'} = $f;
			return 1;
		}
		elsif ($l =~ m/([a-z][a-zA-Z0-9_\.\$]+)\(([A-Za-z0-9_]+\.java):(\d+)\)/) {
			$CONTEXT{'ACT_PATH_LINE'} = $3;
			my @cl = split ('\.', "$1"); pop (@cl); pop (@cl);
			my $f = join ('/', @cl) . "/" . $2;
			$CONTEXT{'ACT_SEARCH_FILE'} = $f;
			return 1;
		}
		elsif ($l =~ m/([a-z][a-zA-Z0-9_\.\$]+) \(([A-Za-z0-9_]+\.java):(\d+)\)/) {
			$CONTEXT{'ACT_PATH_LINE'} = $3;
			my @cl = split ('\.', "$1"); pop (@cl); pop (@cl);
			my $f = join ('/', @cl) . "/" . $2;
			$CONTEXT{'ACT_SEARCH_FILE'} = $f;
			return 1;
		}
	}
	foreach (split ('[\n\t "\';,]', $TEXT)) {
		$l = $_;
		if ($l =~ m/^([a-z0-9]+\.)((([a-z0-9_]+)\.)*?)([A-Z][A-Za-z0-9_]+)$/) {
			my @cl = split ('\.', "$1$2$5");
			my $f = join ('/', @cl);
			$CONTEXT{'ACT_SEARCH_FILE'} = $f . ".java";
			return 1;
		}
		elsif ($l =~ m/(\/.*)(\.java):\[(\d+)/) {
			my $f = "$1$2";
			if (-f $f) {
				$CONTEXT{'ACT_PATH'} = $f;
				$CONTEXT{'ACT_PATH_LINE'} = $3;
				return 1;
			}
		}
	}
	return 0;
}

#################################################################
## for testing purposes
#################################################################

if ($ARGV[0] eq "--test") {
	my $txtin = "";
	while (<STDIN>) {
		$txtin .= $_;
	}

	%CONTEXT = ();
	$CONTEXT{'CTX_TEXT'} = $txtin;

	my $rv = matches_context ();
	if ($rv) {
		foreach (keys (%CONTEXT)) {
			print ($_ . "=" . $CONTEXT{$_} . "\n");
		}
	}
}
